## photoqt 4.2+ds

=== CMakeLists.txt ===
##############################################
# CMakeLists for PhotoQt: http://photoqt.org #
##############################################

cmake_minimum_required(VERSION 3.16)
project(photoqt LANGUAGES CXX)

##################################################################
####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
##################################################################

SET(APPVERSION "4.2")
add_definitions(-DPQMVERSION="${APPVERSION}")

########################################
####  SOME SETTINGS/FLAGS FOR CMAKE ####
########################################

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

#############################
####  GET list of files  ####
#############################

include(CMake/ListFilesCPlusPlus.cmake)
include(CMake/ListFilesQML.cmake)

#############################################
#### OPTIONS THAT CAN BE SET BY THE USER ####
#############################################

option(RAW "Use libraw library" ON)
option(GRAPHICSMAGICK "Use GraphicsMagick library" OFF)
option(IMAGEMAGICK "Use ImageMagick library" ON)
option(DEVIL "Use DevIL library" ON)
option(FREEIMAGE "Use FreeImage library" ON)
option(POPPLER "Use Poppler library" ON)
option(QTPDF "Use QtPDF module instead of Poppler" OFF)
option(LIBARCHIVE "Enable features that require libarchive" ON)
option(VIDEO_QT "Enable video support through Qt" ON)
option(VIDEO_MPV "Enable video support through MPV" ON)
option(LIBVIPS "Use libvips" OFF)
option(RESVG "Replace Qt's SVG engine with resvg for better SVG support" OFF)

option(EXIV2 "Use exiv2 library" ON)
option(EXIV2_ENABLE_BMFF "Enable BMFF format support in Exiv2 (if available)" ON)
option(PUGIXML "Enable features that require pugixml" ON)
option(CHROMECAST "Enable Chromecast support" ON)
option(CHROMECAST_PIPINSTALL "Allows CMake to attempt to install PyChromecast locally using pip." OFF)
option(LOCATION "Enable use of QtPositioning/QtLocation QML modules" ON)
option(MOTIONPHOTO "Enable support for Google Motion Photos and Apple Live Photos" ON)

option(TESTING "Build some unit tests" OFF)
option(RUNCPPCHECK "Analyse source code with cppcheck" OFF)

if(QTPDF)
    if(POPPLER)
        set(POPPLER OFF)
        message("** For displaying PDF documents you have to choose either Poppler OR QtPDF")
    endif()
endif()

################################
#### FIND REQUIRED PACKAGES ####
################################

find_package(Qt6 6.2 REQUIRED COMPONENTS Quick Widgets Sql Core Svg Concurrent Multimedia PrintSupport DBus LinguistTools)
if(TESTING)
    find_package(Qt6 6.2 REQUIRED COMPONENTS Test)
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake")

find_package(ECM REQUIRED NO_MODULE)
list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

if(IMAGEMAGICK)
    find_package(ImageMagick COMPONENTS Magick++)
    if(GRAPHICSMAGICK)
        set(GRAPHICSMAGICK OFF)
        message("** ImageMagick and GraphicsMagick cannot be used at the same time")
    endif()
endif()

if(GRAPHICSMAGICK)
    find_package(GraphicsMagick)
endif()

if(EXIV2)
    find_package(exiv2 REQUIRED)
endif()

if(RAW)
    find_package(LibRaw)
endif()

if(NOT WIN32)
    if(FREEIMAGE)
        find_package(FreeImage)
    endif()
endif()

if(LIBARCHIVE)
    find_package(LibArchive)
endif()

if(NOT WIN32)
    if(POPPLER)
        find_package(Poppler COMPONENTS Qt6)
    endif()
endif()

if(DEVIL)
    find_package(DevIL)
endif()

if(CHROMECAST)
    find_package(Python3 COMPONENTS Interpreter)
endif()

if(LIBVIPS)
    find_package(PkgConfig REQUIRED)
    pkg_search_module(GLIB REQUIRED glib-2.0 gobject-2.0)
endif()

if(VIDEO_MPV)
    find_package(Libmpv)
    set(photoqt_SOURCES ${photoqt_SOURCES} ${photoqt_libmpv_SOURCES})
endif()

if(QTPDF)
    find_package(Qt6 COMPONENTS Pdf REQUIRED)
endif()

######################
#### RUN CPPCHECK ####
######################

if(RUNCPPCHECK)

    # Find CppCheck executable
    find_program(CMAKE_CXX_CPPCHECK NAMES cppcheck)

    # If CppCheck executable found
    if(CMAKE_CXX_CPPCHECK)

        message("** Analyzing source code with cppcheck")

        # Append desired arguments to CppCheck
        list(APPEND CMAKE_CXX_CPPCHECK
                "--enable=warning"
                "--inconclusive"
        )

    endif()

else()

    unset(CMAKE_CXX_CPPCHECK CACHE)

endif()

###############################
#### ADDITIONAL QT OPTIONS ####
###############################

# Since Python might be imported we have to avoid using Qt keywords (like 'slots') to avoid naming conflicts
ADD_DEFINITIONS(-DQT_NO_KEYWORDS)

# we always want to capture debug/log context information
add_definitions(-DQT_MESSAGELOGCONTEXT)

#####################################
#### Handle Qt<6.4 specific stuff ####
#####################################

if(Qt6_VERSION VERSION_LESS 6.5)
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/elements/PQMultiEffect_fake.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/elements/PQMultiEffect.qml")
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/elements/PQBlurBackground_fake.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/elements/PQBlurBackground.qml")
else()
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/elements/PQMultiEffect_real.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/elements/PQMultiEffect.qml")
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/elements/PQBlurBackground_real.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/elements/PQBlurBackground.qml")
endif()

#############################
#### Add the executeable ####
#############################

if(WIN32)
    qt_add_executable(photoqt ${photoqt_SOURCES} ${ALLHEADERS} misc/misc.qrc img/img.qrc img/filetypes.qrc python/python.qrc windowsicons.rc)
else()
    qt_add_executable(photoqt ${photoqt_SOURCES} ${ALLHEADERS} misc/misc.qrc img/img.qrc img/filetypes.qrc python/python.qrc)
endif()

# add qml files
qt_add_qml_module(photoqt URI src VERSION 1.0 QML_FILES ${photoqt_QML})

# set header files as include files
target_include_directories(photoqt PRIVATE "cplusplus/header")

# set some properties for executable
set_target_properties(photoqt PROPERTIES
    MACOSX_BUNDLE_GUI_IDENTIFIER photoqt.PhotoQt.org
    MACOSX_BUNDLE_BUNDLE_VERSION "${APPVERSION}"
    MACOSX_BUNDLE_SHORT_VERSION_STRING "${APPVERSION}"
    MACOSX_BUNDLE TRUE
    WIN32_EXECUTABLE TRUE
)

# link executable
target_link_libraries(photoqt PRIVATE Qt6::Quick Qt6::Widgets Qt6::Sql Qt6::Core Qt6::Svg Qt6::Concurrent Qt6::Multimedia Qt6::PrintSupport Qt6::DBus)

if(QTPDF)
    target_link_libraries(photoqt PRIVATE Qt6::Pdf)
endif()

if(TESTING)
    qt_add_executable(photoqt_test ${photoqt_testscripts_SOURCES} misc/misc.qrc testing/resources/testing.qrc)
    target_link_libraries(photoqt_test PRIVATE Qt6::Quick Qt6::Widgets Qt6::Sql Qt6::Core Qt6::Svg Qt6::Concurrent Qt6::Test)
    target_include_directories(photoqt_test PRIVATE "testing/header")
    target_include_directories(photoqt_test PRIVATE "cplusplus/header")
endif()

##############################################
#### COMPOSE THE APPROPRIATE DESKTOP FILE ####
##############################################

include("CMake/ComposeDesktopFile.cmake")
composeDesktopFile()

######################
#### TRANSLATIONS ####
######################

# the compiled translations are automatically embedded as resource in executable
file(GLOB files "lang/*.ts")
qt_add_translations(photoqt
    TS_FILES ${files}
    RESOURCE_PREFIX "/lang")


########################
#### CUSTOM OPTIONS ####
########################

if(PUGIXML)
    add_definitions(-DPQMPUGIXML)
    target_link_libraries(photoqt PRIVATE "pugixml")
    if(TESTING)
        target_link_libraries(photoqt_test PRIVATE "pugixml")
    endif()
endif()

if(VIDEO_QT)
    add_definitions(-DPQMVIDEOQT)
endif()

if(LIBARCHIVE)
    if(NOT ${LibArchive_FOUND})
        message(FATAL_ERROR "** Unable to locate LibArchive... is it installed?")
    else()
        message("** Using LibArchive " ${LibArchive_VERSION})
        add_definitions(-DPQMLIBARCHIVE)
        include_directories(${LibArchive_INCLUDE_DIRS})
        target_link_libraries(photoqt PRIVATE ${LibArchive_LIBRARIES})
        if(TESTING)
            target_link_libraries(photoqt_test PRIVATE ${LibArchive_LIBRARIES})
        endif()
    endif()
else()
    message("** LibArchive disabled")
endif()

if(POPPLER)
    if(WIN32)
        message("** Using Poppler")
        add_definitions(-DPQMPOPPLER)
        target_link_libraries(photoqt PRIVATE "poppler")
        target_link_libraries(photoqt PRIVATE "poppler-qt6")
        if(TESTING)
            target_link_libraries(photoqt_test PRIVATE "poppler")
            target_link_libraries(photoqt_test PRIVATE "poppler-qt6")
        endif()
    else()
        if(NOT ${Poppler_FOUND})
            message(FATAL_ERROR "** Unable to locate Poppler... is it installed?")
        else()
            message("** Using Poppler ${Poppler_VERSION}")
            include_directories(${Poppler_INCLUDE_DIRS})
            add_definitions(-DPQMPOPPLER)
            target_link_libraries(photoqt PRIVATE ${Poppler_LIBRARIES})
            if(TESTING)
                target_link_libraries(photoqt_test PRIVATE ${Poppler_LIBRARIES})
            endif()
        endif()
    endif()
else()
    message("** Poppler DISABLED")
endif()

if(QTPDF)
    message("** Using QtPDF module")
    add_definitions(-DPQMQTPDF)
endif()

if(DEVIL)
    if(WIN32)
        target_link_libraries(photoqt PRIVATE "DevIL")
        message("** Using DevIL")
        add_definitions(-DPQMDEVIL)
    else()
        if(NOT ${DevIL_FOUND})
            message(FATAL_ERROR "** Unable to locate DevIL... is it installed?")
        else()
            message("** Using DevIL")
            include_directories(${IL_INCLUDE_DIR})
            add_definitions(-DPQMDEVIL)
            target_link_libraries(photoqt PRIVATE ${IL_LIBRARIES})
            if(TESTING)
                target_link_libraries(photoqt_test PRIVATE ${IL_LIBRARIES})
            endif()
        endif()
    endif()
else()
    message("** DevIL DISABLED")
endif()

if(FREEIMAGE)
    if(WIN32)
        target_link_libraries(photoqt PRIVATE "FreeImage")
        message("** Using FreeImage")
        add_definitions(-DPQMFREEIMAGE)
    else()
        if(NOT ${FREEIMAGE_FOUND})
            message(FATAL_ERROR "** Unable to locate FreeImage... is it installed?")
        else()
            message("** Using FreeImage")
            include_directories(${FREEIMAGE_INCLUDE_DIRS})
            add_definitions(-DPQMFREEIMAGE)
            target_link_libraries(photoqt PRIVATE ${FREEIMAGE_C_LIBRARY})
            if(TESTING)
                target_link_libraries(photoqt_test PRIVATE ${FREEIMAGE_C_LIBRARY})
            endif()
        endif()
    endif()
else()
    message("** FreeImage DISABLED")
endif()

if(RAW)
    if(NOT ${LIBRAW_FOUND})
        message(FATAL_ERROR "** Unable to locate LibRaw... is it installed?")
    else()
        message("** Using LibRaw")
        add_definitions(-DPQMRAW)
        include_directories(${LIBRAW_INCLUDE_DIR})
        if(WIN32)
            target_link_libraries(photoqt PRIVATE "libraw")
            if(TESTING)
                target_link_libraries(photoqt_test PRIVATE "libraw")
            endif()
        else()
            target_link_libraries(photoqt PRIVATE "raw")
            if(TESTING)
                target_link_libraries(photoqt_test PRIVATE "raw")
            endif()
        endif()
    endif()
else()
    message("** LibRaw DISABLED")
endif()

if(EXIV2)
    if(NOT ${exiv2_FOUND})
        message(FATAL_ERROR "** Unable to locate Exiv2... is it installed?")
    else()
        message("** Using Exiv2 ${exiv2_VERSION}")

=== debian/changelog ===
photoqt (4.2+ds-3) unstable; urgency=medium

  * Add missing Depends.

 -- Gürkan Myczko <tar@debian.org>  Mon, 05 Feb 2024 08:40:35 +0100

photoqt (4.2+ds-2) unstable; urgency=medium

  * Disable libresvg-dev support.

 -- Gürkan Myczko <tar@debian.org>  Wed, 24 Jan 2024 14:58:36 +0100

photoqt (4.2+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/control: add libresvg-dev to build-depends.
  * d/rules: enable resvg usage.

 -- Gürkan Myczko <tar@debian.org>  Wed, 24 Jan 2024 12:16:22 +0100

photoqt (4.0.1+ds-1) unstable; urgency=medium

  * Ack NMU, dropped patches/ as upstreamed.
  * New upstream version.
  * d/control: build-depends add qt6-svg-dev, libpoppler-qt6-dev, and some
    more qt6 dependencies, drop all qt5 dependencies.
  * d/copyright: add windowsicons.rc to Files-Excluded, drop snap.

 -- Gürkan Myczko <tar@debian.org>  Mon, 18 Dec 2023 07:52:42 +0100

=== debian/control ===
Source: photoqt
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 extra-cmake-modules,
 libexiv2-dev,
 libmagick++-6.q16-dev [!kfreebsd-amd64 !kfreebsd-i386],
 libgraphicsmagick1-dev,
 libgraphicsmagick++1-dev,
 libraw-dev,
 libfreeimageplus-dev,
 libdevil-dev,
 libvips-dev,
 libmpv-dev,
 libpoppler-cpp-dev,
 libarchive-dev,
 libpugixml-dev,
 libpoppler-qt6-dev,
 libpoppler-private-dev,
 qt6-svg-dev,
 python3-pip,
 python3-dev,
 python3-requests,
 python3-pychromecast,
 qt6-base-dev,
 qt6-base-dev-tools,
 qmake6,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 qt6-quick3d-dev,
 qt6-quick3d-dev-tools,
 qt6-multimedia-dev,
 qt6-declarative-dev,
 qt6-declarative-dev-tools
Standards-Version: 4.6.2
Homepage: https://photoqt.org/
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/photoqt
Vcs-Git: https://salsa.debian.org/debian-phototools-team/photoqt.git
Rules-Requires-Root: no

Package: photoqt
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 python3-pychromecast,
 qml6-module-qt-labs-platform,
 qml6-module-qtmultimedia,
 qml6-module-qtquick-localstorage,
Recommends: kimageformat-plugins
Description: Fast and highly configurable image viewer
 This is a fast and highly configurable image viewer with a simple and nice
 interface.

## photoqt 4.4%2Bds

=== debian/changelog ===
photoqt (4.4+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/control: add liblcms2-dev to build-depends.

 -- Gürkan Myczko <tar@debian.org>  Mon, 08 Apr 2024 14:03:28 +0200

photoqt (4.3+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/control: add build-depends libzxing-dev.

 -- Gürkan Myczko <tar@debian.org>  Mon, 18 Mar 2024 00:38:13 +0100

## photoqt 4.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-SET(APPVERSION "4.2")
+SET(APPVERSION "4.4")
 add_definitions(-DPQMVERSION="${APPVERSION}")
 
 ########################################
@@ -47,6 +47,7 @@
 option(VIDEO_MPV "Enable video support through MPV" ON)
 option(LIBVIPS "Use libvips" OFF)
 option(RESVG "Replace Qt's SVG engine with resvg for better SVG support" OFF)
+option(ZXING "Support for QR and barcodes detection (using ZXing)" ON)
 
 option(EXIV2 "Use exiv2 library" ON)
 option(EXIV2_ENABLE_BMFF "Enable BMFF format support in Exiv2 (if available)" ON)
@@ -55,14 +56,18 @@
 option(CHROMECAST_PIPINSTALL "Allows CMake to attempt to install PyChromecast locally using pip." OFF)
 option(LOCATION "Enable use of QtPositioning/QtLocation QML modules" ON)
 option(MOTIONPHOTO "Enable support for Google Motion Photos and Apple Live Photos" ON)
+option(PHOTOSPHERE "Enable support for photo spheres and 360 degree panoramic views" ON)
+option(LCMS2 "Enable advanced color management with LCMS2" ON)
 
 option(TESTING "Build some unit tests" OFF)
 option(RUNCPPCHECK "Analyse source code with cppcheck" OFF)
+option(FLATPAKBUILD "Enable this if this is a build for Flatpak" OFF)
 
 if(QTPDF)
     if(POPPLER)
         set(POPPLER OFF)
-        message("** For displaying PDF documents you have to choose either Poppler OR QtPDF")
+        message("** For displaying PDF documents you have to choose either Poppler OR QtPDF.")
+        message("** Poppler has been automatically disabled in favour of QtPDF.")
     endif()
 endif()
 
@@ -84,7 +89,8 @@
     find_package(ImageMagick COMPONENTS Magick++)
     if(GRAPHICSMAGICK)
         set(GRAPHICSMAGICK OFF)
-        message("** ImageMagick and GraphicsMagick cannot be used at the same time")
+        message("** ImageMagick and GraphicsMagick cannot be used at the same time.")
+        message("** GraphicsMagick has been automatically disabled in favour of ImageMagick.")
     endif()
 endif()
 
@@ -136,6 +142,28 @@
 
 if(QTPDF)
     find_package(Qt6 COMPONENTS Pdf REQUIRED)
+endif()
+
+if(ZXING)
+    find_package(ZXing)
+endif()
+
+if(PHOTOSPHERE)
+    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere_real.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere.qml")
+    set(photoqt_SOURCES ${photoqt_SOURCES} ${photoqt_ps_SOURCES})
+else()
+    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere_fake.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere.qml")
+endif()
+
+if(LCMS2)
+    find_package(LCMS2)
+endif()
+
+if(FLATPAKBUILD)
+    find_package(PkgConfig REQUIRED)
+    pkg_search_module(GLIB REQUIRED glib-2.0 gobject-2.0 gio-2.0)
 endif()
 
 ######################
@@ -156,6 +184,7 @@
         list(APPEND CMAKE_CXX_CPPCHECK
                 "--enable=warning"
                 "--inconclusive"
+                "--library=qt"
         )
 
     endif()
@@ -203,7 +232,7 @@
 endif()
 
 # add qml files
-qt_add_qml_module(photoqt URI src VERSION 1.0 QML_FILES ${photoqt_QML})
+qt_add_qml_module(photoqt URI src VERSION 1.0 QML_FILES ${photoqt_QML} RESOURCE_PREFIX)
 
 # set header files as include files
 target_include_directories(photoqt PRIVATE "cplusplus/header")
@@ -345,43 +374,3 @@
             message(FATAL_ERROR "** Unable to locate FreeImage... is it installed?")
         else()
             message("** Using FreeImage")
-            include_directories(${FREEIMAGE_INCLUDE_DIRS})
-            add_definitions(-DPQMFREEIMAGE)
-            target_link_libraries(photoqt PRIVATE ${FREEIMAGE_C_LIBRARY})
-            if(TESTING)
-                target_link_libraries(photoqt_test PRIVATE ${FREEIMAGE_C_LIBRARY})
-            endif()
-        endif()
-    endif()
-else()
-    message("** FreeImage DISABLED")
-endif()
-
-if(RAW)
-    if(NOT ${LIBRAW_FOUND})
-        message(FATAL_ERROR "** Unable to locate LibRaw... is it installed?")
-    else()
-        message("** Using LibRaw")
-        add_definitions(-DPQMRAW)
-        include_directories(${LIBRAW_INCLUDE_DIR})
-        if(WIN32)
-            target_link_libraries(photoqt PRIVATE "libraw")
-            if(TESTING)
-                target_link_libraries(photoqt_test PRIVATE "libraw")
-            endif()
-        else()
-            target_link_libraries(photoqt PRIVATE "raw")
-            if(TESTING)
-                target_link_libraries(photoqt_test PRIVATE "raw")
-            endif()
-        endif()
-    endif()
-else()
-    message("** LibRaw DISABLED")
-endif()
-
-if(EXIV2)
-    if(NOT ${exiv2_FOUND})
-        message(FATAL_ERROR "** Unable to locate Exiv2... is it installed?")
-    else()
-        message("** Using Exiv2 ${exiv2_VERSION}")

=== debian/control ===
--- 
+++ 
@@ -20,6 +20,7 @@
  libpugixml-dev,
  libpoppler-qt6-dev,
  libpoppler-private-dev,
+ libzxing-dev,
  qt6-svg-dev,
  python3-pip,
  python3-dev,

=== debian/watch ===
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%" \
   https://github.com/luspi/photoqt/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## photoqt 4.5+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-SET(APPVERSION "4.4")
+SET(APPVERSION "4.5")
 add_definitions(-DPQMVERSION="${APPVERSION}")
 
 ########################################
@@ -149,12 +149,7 @@
 endif()
 
 if(PHOTOSPHERE)
-    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
-                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere_real.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere.qml")
     set(photoqt_SOURCES ${photoqt_SOURCES} ${photoqt_ps_SOURCES})
-else()
-    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
-                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere_fake.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere.qml")
 endif()
 
 if(LCMS2)
@@ -374,3 +369,17 @@
             message(FATAL_ERROR "** Unable to locate FreeImage... is it installed?")
         else()
             message("** Using FreeImage")
+            include_directories(${FREEIMAGE_INCLUDE_DIRS})
+            add_definitions(-DPQMFREEIMAGE)
+            target_link_libraries(photoqt PRIVATE ${FREEIMAGE_C_LIBRARY})
+            if(TESTING)
+                target_link_libraries(photoqt_test PRIVATE ${FREEIMAGE_C_LIBRARY})
+            endif()
+        endif()
+    endif()
+else()
+    message("** FreeImage DISABLED")
+endif()
+
+if(RAW)
+    if(NOT ${LIBRAW_FOUND})

=== debian/changelog ===
photoqt (4.5+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.

 -- Alex Myczko <tar@debian.org>  Sun, 19 May 2024 23:06:19 +0200

## photoqt 4.6+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-SET(APPVERSION "4.5")
+SET(APPVERSION "4.6")
 add_definitions(-DPQMVERSION="${APPVERSION}")
 
 ########################################

=== debian/changelog ===
photoqt (4.6+ds-1build1) plucky; urgency=medium

  * No-change rebuild for libexiv2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 01 Nov 2024 12:17:48 +0000

photoqt (4.6+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Sun, 11 Aug 2024 07:17:50 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: graphics
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
-Uploaders: Gürkan Myczko <tar@debian.org>
+Uploaders: Alex Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
  extra-cmake-modules,

## photoqt 4.8.1%2Bds

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifeq ($(DEB_BUILD_ARCH_OS),kfreebsd)
    MAGICK = -DGRAPHICSMAGICK=OFF -DIMAGEMAGICK=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_POPPLER=OFF \
	-DVIDEO_MPV=ON \
	-DLIBVIPS=ON \
	-DRESVG=OFF \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	$(MAGICK)

## photoqt 4.8.1+ds

=== CMakeLists.txt ===
##############################################
# CMakeLists for PhotoQt: http://photoqt.org #
##############################################

cmake_minimum_required(VERSION 3.26)
project(photoqt LANGUAGES CXX)

##################################################################
####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
##################################################################

SET(APPVERSION "4.8.1")

########################################
####  SOME SETTINGS/FLAGS FOR CMAKE ####
########################################

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

#############################
####  GET list of files  ####
#############################

include(CMake/ListFilesCPlusPlus.cmake)
include(CMake/ListFilesQML.cmake)

#############################################
#### OPTIONS THAT CAN BE SET BY THE USER ####
#############################################

option(WITH_IMAGEMAGICK           "Configure with support for the ImageMagick library" ON)
option(WITH_GRAPHICSMAGICK        "Configure with support for the GraphicsMagick library" OFF)
option(WITH_LIBRAW                "Configure with support for the libraw library" ON)
option(WITH_DEVIL                 "Configure with support for the DevIL library" ON)
option(WITH_FREEIMAGE             "Configure with support for the FreeImage library" ON)
option(WITH_POPPLER               "Configure with support for the Poppler library" ON)
option(WITH_QTPDF                 "Configure with support for the QtPDF module (instead of Poppler)" OFF)
option(WITH_LIBARCHIVE            "Configure with support for the libarchive library" ON)
option(WITH_VIDEO_QT              "Configure with video support through Qt" ON)
option(WITH_VIDEO_MPV             "Configure with video support through MPV" ON)
option(WITH_LIBVIPS               "Configure with support for the libvips library" OFF)
option(WITH_RESVG                 "Configure with support for the resvg library (better SVG support)" OFF)

option(WITH_EXIV2                 "Configure with support for the Exiv2 library" ON)
option(WITH_EXIV2_ENABLE_BMFF     "Configure with BMFF format support in Exiv2 (if available) - only needed for Exiv2 0.27.x and before" ON)
option(WITH_PUGIXML               "Configure with support for the pugixml library" ON)
option(WITH_ZXING                 "Configure with support for the ZXing library (QR and barcodes detection)" ON)
option(WITH_CHROMECAST            "Configure with support for Chromecast (through Python)" ON)
option(WITH_CHROMECAST_PIPINSTALL "Allows CMake to attempt to install PyChromecast locally using pip" OFF)
option(WITH_LOCATION              "Configure with support for the QtPositioning/QtLocation QML modules" ON)
option(WITH_LCMS2                 "Configure with support for the Little CMS library (advanced color management)" ON)
option(WITH_MOTIONPHOTO           "Configure with support for Google Motion Photos and Apple Live Photos" ON)
option(WITH_PHOTOSPHERE           "Configure with support for photo spheres and 360 degree panoramic views" ON)

option(WITH_TESTING               "Enable and build some unit tests" OFF)
option(WITH_RUNCPPCHECK           "Analyse source code with cppcheck" OFF)
option(WITH_FLATPAKBUILD          "Enable this option if this is a build for Flatpak" OFF)
option(WITH_ADAPTSOURCE           "Adapt and change the source files for the current Qt version (if necessary)" OFF)
option(WITHOUT_ICU                "Enable this option if your Qt6 setup has no ICU support" OFF)
option(WITH_PORTABLETWEAKS        "Apply tweaks for a build of a portable version" OFF)


##################################################################################################################
# The options above were renamed for 4.8.1
# For the time being we still check for the old names and pass any value on to the new options
if(DEFINED IMAGEMAGICK)
    message("** The IMAGEMAGICK option is deprecated, use WITH_IMAGEMAGICK instead: ${IMAGEMAGICK}")
    set(WITH_IMAGEMAGICK ${IMAGEMAGICK} CACHE BOOL "Configure with support for the ImageMagick library" FORCE)
    unset(IMAGEMAGICK CACHE)
endif()
if(DEFINED GRAPHICSMAGICK)
    message("** The GRAPHICSMAGICK option is deprecated, use WITH_GRAPHICSMAGICK instead")
    set(WITH_GRAPHICSMAGICK ${GRAPHICSMAGICK} CACHE BOOL "Configure with support the for GraphicsMagick library" FORCE)
    unset(GRAPHICSMAGICK CACHE)
endif()
if(DEFINED RAW)
    message("** The RAW option is deprecated, use WITH_LIBRAW instead")
    set(WITH_LIBRAW ${RAW} CACHE BOOL "Configure with support for the libraw library" FORCE)
    unset(RAW CACHE)
endif()
if(DEFINED DEVIL)
    message("** The DEVIL option is deprecated, use WITH_DEVIL instead")
    set(WITH_DEVIL ${DEVIL} CACHE BOOL "Configure with support for the DevIL library" FORCE)
    unset(DEVIL CACHE)
endif()
if(DEFINED FREEIMAGE)
    message("** The FREEIMAGE option is deprecated, use WITH_FREEIMAGE instead")
    set(WITH_FREEIMAGE ${FREEIMAGE} CACHE BOOL "Configure with support for the FreeImage library" FORCE)
    unset(FREEIMAGE CACHE)
endif()
if(DEFINED POPPLER)
    message("** The POPPLER option is deprecated, use WITH_POPPLER instead")
    set(WITH_POPPLER ${POPPLER} CACHE BOOL "Configure with support for the Poppler library" FORCE)
    unset(POPPLER CACHE)
endif()
if(DEFINED QTPDF)
    message("** The QTPDF option is deprecated, use WITH_QTPDF instead")
    set(WITH_QTPDF ${QTPDF} CACHE BOOL "Configure with support for the QtPDF module (instead of Poppler)" FORCE)
    unset(QTPDF CACHE)
endif()
if(DEFINED LIBARCHIVE)
    message("** The LIBARCHIVE option is deprecated, use WITH_LIBARCHIVE instead")
    set(WITH_LIBARCHIVE ${LIBARCHIVE} CACHE BOOL "Configure with support for the libarchive library" FORCE)
    unset(LIBARCHIVE CACHE)
endif()
if(DEFINED VIDEO_QT)
    message("** The VIDEO_QT option is deprecated, use WITH_VIDEO_QT instead")
    set(WITH_VIDEO_QT ${VIDEO_QT} CACHE BOOL "Configure with video support through Qt" FORCE)
    unset(VIDEO_QT CACHE)
endif()
if(DEFINED VIDEO_MPV)
    message("** The VIDEO_MPV option is deprecated, use WITH_VIDEO_MPV instead")
    set(WITH_VIDEO_MPV ${VIDEO_MPV} CACHE BOOL "Configure with video support through MPV" FORCE)
    unset(VIDEO_MPV CACHE)
endif()
if(DEFINED LIBVIPS)
    message("** The LIBVIPS option is deprecated, use WITH_LIBVIPS instead")
    set(WITH_LIBVIPS ${LIBVIPS} CACHE BOOL "Configure with support for the libvips library" FORCE)
    unset(LIBVIPS CACHE)
endif()
if(DEFINED RESVG)
    message("** The RESVG option is deprecated, use WITH_RESVG instead")
    set(WITH_RESVG ${RESVG} CACHE BOOL "Configure with support for the resvg library (better SVG support)" FORCE)
    unset(RESVG CACHE)
endif()
if(DEFINED EXIV2)
    message("** The EXIV2 option is deprecated, use WITH_EXIV2 instead")
    set(WITH_EXIV2 ${EXIV2} CACHE BOOL "Configure with support for the Exiv2 library" FORCE)
    unset(EXIV2 CACHE)
endif()
if(DEFINED EXIV2_ENABLE_BMFF)
    message("** The EXIV2_ENABLE_BMFF option is deprecated, use WITH_EXIV2_ENABLE_BMFF instead")
    set(WITH_EXIV2_ENABLE_BMFF ${EXIV2_ENABLE_BMFF} CACHE BOOL "Configure with BMFF format support in Exiv2 (if available) - only needed for Exiv2 0.27.x and before" FORCE)
    unset(EXIV2_ENABLE_BMFF CACHE)
endif()
if(DEFINED PUGIXML)
    message("** The PUGIXML option is deprecated, use WITH_PUGIXML instead")
    set(WITH_PUGIXML ${PUGIXML} CACHE BOOL "Configure with support for the pugixml library" FORCE)
    unset(PUGIXML CACHE)
endif()
if(DEFINED ZXING)
    message("** The ZXING option is deprecated, use WITH_ZXING instead")
    set(WITH_ZXING ${ZXING} CACHE BOOL "Configure with support for the ZXing library (QR and barcodes detection)" FORCE)
    unset(ZXING CACHE)
endif()
if(DEFINED CHROMECAST)
    message("** The CHROMECAST option is deprecated, use WITH_CHROMECAST instead")
    set(WITH_CHROMECAST ${CHROMECAST} CACHE BOOL "Configure with support for Chromecast (through Python)" FORCE)
    unset(CHROMECAST CACHE)
endif()
if(DEFINED CHROMECAST_PIPINSTALL)
    message("** The CHROMECAST_PIPINSTALL option is deprecated, use WITH_CHROMECAST_PIPINSTALL instead")
    set(WITH_CHROMECAST_PIPINSTALL ${CHROMECAST_PIPINSTALL} CACHE BOOL "Allows CMake to attempt to install PyChromecast locally using pip" FORCE)
    unset(CHROMECAST_PIPINSTALL CACHE)
endif()
if(DEFINED LOCATION)
    message("** The LOCATION option is deprecated, use WITH_LOCATION instead")
    set(WITH_LOCATION ${LOCATION} CACHE BOOL "Configure with support for the QtPositioning/QtLocation QML modules" FORCE)
    unset(LOCATION CACHE)
endif()
if(DEFINED LCMS2)
    message("** The LCMS2 option is deprecated, use WITH_LCMS2 instead")
    set(WITH_LCMS2 ${LCMS2} CACHE BOOL "Configure with support for the Little CMS library (advanced color management)" FORCE)
    unset(LCMS2 CACHE)
endif()
if(DEFINED MOTIONPHOTO)
    message("** The MOTIONPHOTO option is deprecated, use WITH_MOTIONPHOTO instead")
    set(WITH_MOTIONPHOTO ${MOTIONPHOTO} CACHE BOOL "Configure with support for Google Motion Photos and Apple Live Photos" FORCE)
    unset(MOTIONPHOTO CACHE)
endif()
if(DEFINED PHOTOSPHERE)
    message("** The PHOTOSPHERE option is deprecated, use WITH_PHOTOSPHERE instead")
    set(WITH_PHOTOSPHERE ${PHOTOSPHERE} CACHE BOOL "Configure with support for photo spheres and 360 degree panoramic views" FORCE)
    unset(PHOTOSPHERE CACHE)
endif()

if(DEFINED TESTING)
    message("** The TESTING option is deprecated, use WITH_TESTING instead")
    set(WITH_TESTING ${TESTING} CACHE BOOL "Enable and build some unit tests" FORCE)
    unset(TESTING CACHE)
endif()
if(DEFINED RUNCPPCHECK)
    message("** The RUNCPPCHECK option is deprecated, use WITH_RUNCPPCHECK instead")
    set(WITH_RUNCPPCHECK ${RUNCPPCHECK} CACHE BOOL "Analyse source code with cppcheck" FORCE)
    unset(RUNCPPCHECK CACHE)
endif()
if(DEFINED FLATPAKBUILD)
    message("** The FLATPAKBUILD option is deprecated, use WITH_FLATPAKBUILD instead")
    set(WITH_FLATPAKBUILD ${FLATPAKBUILD} CACHE BOOL "Enable this option if this is a build for Flatpak" FORCE)
    unset(FLATPAKBUILD CACHE)
endif()
if(DEFINED ADAPT_SOURCE)
    message("** The ADAPT_SOURCE option is deprecated, use WITH_ADAPTSOURCE instead")
    set(WITH_ADAPTSOURCE ${ADAPT_SOURCE} CACHE BOOL "Adapt and change the source files for the current Qt version (if necessary)" FORCE)
    unset(ADAPT_SOURCE CACHE)
endif()
if(DEFINED WITHOUTICU)
    message("** The WITHOUTICU option is deprecated, use WITHOUT_ICU instead")
    set(WITHOUT_ICU ${WITHOUTICU} CACHE BOOL "Enable this option if your Qt6 setup has no ICU support" FORCE)
    unset(WITHOUTICU CACHE)
endif()
##################################################################################################################
##################################################################################################################

#####################################
#### RESOLVE CONFLICTING OPTIONS ####
#####################################

if(WITH_QTPDF)
    if(WITH_POPPLER)
        set(WITH_POPPLER OFF)
        message("** For displaying PDF documents you have to choose either Poppler OR QtPDF.")
        message("** Poppler has been automatically disabled in favour of QtPDF.")
    endif()
endif()

if(WITH_IMAGEMAGICK)
    if(WITH_GRAPHICSMAGICK)
        set(WITH_GRAPHICSMAGICK OFF)
        message("** ImageMagick and GraphicsMagick cannot be used at the same time.")
        message("** GraphicsMagick has been automatically disabled in favour of ImageMagick.")
    endif()
endif()

################################
#### FIND REQUIRED PACKAGES ####
################################

find_package(Qt6 6.4 REQUIRED COMPONENTS Quick Widgets Sql Core Svg Concurrent Multimedia PrintSupport DBus LinguistTools)
if(WITH_TESTING)
    find_package(Qt6 6.4 REQUIRED COMPONENTS Test)
endif()

=== debian/changelog ===
photoqt (4.8.1+ds-1build2) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Tue, 16 Sep 2025 21:38:41 +0100

photoqt (4.8.1+ds-1build1) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.3 (LP: #2103945).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 29 Mar 2025 15:12:32 -0500

photoqt (4.8.1+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Mon, 17 Feb 2025 10:11:13 +0000

photoqt (4.6+ds-2) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * d/control: drop version from libmagick++-dev dependecy. (Closes: #1086940)

 -- Alex Myczko <tar@debian.org>  Wed, 20 Nov 2024 12:03:23 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: photoqt
 Section: graphics
 Priority: optional
-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Alex Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
  extra-cmake-modules,
  libexiv2-dev,
- libmagick++-6.q16-dev [!kfreebsd-amd64 !kfreebsd-i386],
+ libmagick++-dev [!kfreebsd-amd64 !kfreebsd-i386],
  libgraphicsmagick1-dev,
  libgraphicsmagick++1-dev,
  libraw-dev,
@@ -36,7 +37,7 @@
  qt6-multimedia-dev,
  qt6-declarative-dev,
  qt6-declarative-dev-tools
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://photoqt.org/
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/photoqt
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/photoqt.git

## photoqt 4.9.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,13 +3,13 @@
 ##############################################
 
 cmake_minimum_required(VERSION 3.26)
-project(photoqt LANGUAGES CXX)
+project(photoqt LANGUAGES C CXX)
 
 ##################################################################
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-SET(APPVERSION "4.8.1")
+SET(APPVERSION "4.9.2")
 
 ########################################
 ####  SOME SETTINGS/FLAGS FOR CMAKE ####
@@ -29,6 +29,7 @@
 
 include(CMake/ListFilesCPlusPlus.cmake)
 include(CMake/ListFilesQML.cmake)
+include(CMake/ListFilesExtensions.cmake)
 
 #############################################
 #### OPTIONS THAT CAN BE SET BY THE USER ####
@@ -64,6 +65,7 @@
 option(WITH_ADAPTSOURCE           "Adapt and change the source files for the current Qt version (if necessary)" OFF)
 option(WITHOUT_ICU                "Enable this option if your Qt6 setup has no ICU support" OFF)
 option(WITH_PORTABLETWEAKS        "Apply tweaks for a build of a portable version" OFF)
+option(WITH_WAYLANDSPECIFIC      "Enable optional Wayland-specific code to allow for further optimizations." OFF)
 
 
 ##################################################################################################################
@@ -232,8 +234,3 @@
 #### FIND REQUIRED PACKAGES ####
 ################################
 
-find_package(Qt6 6.4 REQUIRED COMPONENTS Quick Widgets Sql Core Svg Concurrent Multimedia PrintSupport DBus LinguistTools)
-if(WITH_TESTING)
-    find_package(Qt6 6.4 REQUIRED COMPONENTS Test)
-endif()
-

=== debian/changelog ===
photoqt (4.9.2+ds-1) unstable; urgency=medium

  * Team upload.
  * d/watch: add opts for repacksuffix +ds
  * New upstream version 4.9.2+ds
  * Bump Standards-Version: 4.7.2
  * d/copyright: add License: CC0-1.0 for org.photoqt.PhotoQt.metainfo.xml

 -- xiao sheng wen <atzlinux@debian.org>  Tue, 26 Aug 2025 17:42:44 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: photoqt
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Alex Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
@@ -37,7 +36,7 @@
  qt6-multimedia-dev,
  qt6-declarative-dev,
  qt6-declarative-dev-tools
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://photoqt.org/
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/photoqt
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/photoqt.git

=== debian/watch ===
version=4

opts="dversionmangle=s/\.ds//,repack,repacksuffix=+ds" \
   https://github.com/luspi/photoqt/tags .*/v?(\d\S+)\.tar\.gz
